initial suppport for raid 10
authorIan Kelling <ian@iankelling.org>
Sat, 13 Feb 2016 21:34:33 +0000 (13:34 -0800)
committerIan Kelling <ian@iankelling.org>
Mon, 6 Feb 2017 06:21:40 +0000 (22:21 -0800)
Also, using stable for test vm, since testing kernel
started freezing for a while on boot and printing a few stack traces.

fai-revm
fai/config/class/50-host-classes
fai/config/hooks/partition.DEFAULT

index 9c8fd9c89f528cd7cc0040c72ae17dc1099faa56..d9bacf4d48be6592eba0e2a7d0a03256bf9e1566 100755 (executable)
--- a/fai-revm
+++ b/fai-revm
@@ -8,6 +8,20 @@ set -x
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
 
+
+disk_count=4
+
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+
+if [[ $script_dir == /a/bin/* ]]; then
+    rm -rf /a/tmp/fai2
+    cp -r /a/bin/fai /a/tmp/fai2
+    exec /a/tmp/fai2/fai-revm "$@"
+fi
+
+cd $(dirname $(readlink -f "$BASH_SOURCE"))
+
+
 new_disk=false
 [[ ! $1 ]] || new_disk=true
 
@@ -25,13 +39,16 @@ name=demohost
 
 s virshrm $name ||:
 
-for f in /var/lib/libvirt/images/${name}{,b}; do
+disk_arg=()
+for ((i=1; i <= disk_count; i++)); do
+    f=/var/lib/libvirt/images/${name}$i
+    disk_arg+=("--disk path=$f")
     if $new_disk || [[ ! -e $f ]]; then
-        s qemu-img create -o preallocation=metadata -f qcow2 $f 30G
+        rm -f $f
+        s qemu-img create -o preallocation=metadata -f qcow2 $f 20G
     fi
 done
 
-disk_arg=("--disk path=/var/lib/libvirt/images/$name"{,b})
 s virt-install --os-variant $variant --cpu host -n $name --pxe -r 2048 --vcpus 1 \
   ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad &
 
index 6989eb909b18b852aa9170d3c68f8d8098f3c82b..27c1e1b7cf84752ce8286dfefa64d3a8060bec08 100755 (executable)
@@ -8,7 +8,7 @@
 # use a list of classes for our demo machine
 case $HOSTNAME in
     demohost)
-        echo "FAIBASE DEBIAN DESKTOP TWO_DISK" ;;
+        echo "FAIBASE DEBIAN DESKTOP MANY_DISK STABLE" ;;
     x2)
         echo "FAIBASE DEBIAN DESKTOP ONE_DISK" ;;
     tp)
index 19438042a79c5baa9f5a171b89e62e7eee6b41ce..c45c4dc67a0917002d3393d6a84b3dd65d354e66 100755 (executable)
@@ -6,42 +6,59 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
 # # fai's setup-storage won't do btrfs on luks,
 # # so we do it ourself :)
 
+skiptask partition ||: # for running out of fai
 
 #### begin configuration
 
-if ifclass TWO_DISK || ifclass demohost; then
+bootn=1
+swapn=2
+rootn=3
+bios_grubn=4
+boot_end=804
+lastn=$bios_grubn
+
+if ifclass VM; then
+    d=vd
+else
+    d=sd
+fi
+
+letters=()
+if ifclass TWO_DISK; then
     letters=(a b)
 elif ifclass ONE_DISK; then
     letters=(a)
+elif ifclass MANY_DISK; then
+    for dev in /dev/${d}?; do letters+=(${dev#/dev/${d}}); done
 else
     exit 1
 fi
 ##### end configuration
 
-if ifclass VM; then
-    d=vd
-else
-    d=sd
-fi
-
 
+bpart() {
+    dev_n=$1
+    case ${#@} in
+        [1-3]) mkfs.btrfs -f $@ ;;
+        [4-9]*|[1-3]?*) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
+    esac
+}
 
-skiptask partition ||: # for running out of fai
 devs=(${letters[@]/#//dev/${d}})
 crypt_devs=(${letters[@]/#//dev/mapper/crypt_dev_${d}})
 
-partition=false
+partition=true
 
 # somewhat crude detection of whether to partition
 for dev in ${devs[@]}; do
     x=($dev[0-9])
-    [[ ${#x[@]}  == 4 ]] || partition=true
-    for part in ${dev}{1,2,3,4}; do
-        [[ -e $part ]] || partition=true
+    [[ ${#x[@]}  == ${lastn} ]] || partition=true
+    for (( i=1; i <= $lastn; i++ )); do
+        [[ -e ${dev}$i ]] || partition=true
     done
-    # type tells us it's not totally blank
-    for part in ${dev}{1,3}; do
-        blkid | grep "^$part:.*TYPE=" &>/dev/null || partition=true
+    for part in $dev$rootn $dev$bootn; do
+        # type tells us it's not totally blank
+        blkid | grep "^${part}:.*TYPE=" &>/dev/null || partition=true
     done
 done
 
@@ -59,31 +76,17 @@ if ifclass demohost; then
     lukspw=x
 fi
 
-boot_end=504
-
-crypt=/dev/mapper/crypt_dev_${d##/dev/}a3
 
+crypt=/dev/mapper/crypt_dev_${d##/dev/}a$rootn
 
 
-# 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
-swap_end=$(( $(grep ^MemTotal: /proc/meminfo| awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1000 + boot_end ))
-
-create_subvols() {
-    cd /mnt
-    for x in q home root; do
-        btrfs subvolume list . | grep "$x$" >/dev/null || btrfs subvolume create $x
-    done
-    for x in root/a q/a; do
-        mkdir -p $x
-        chown 1000:1000 $x
-        chmod 755 $x
-    done
-    btrfs subvolume set-default \
-          $(btrfs subvolume list . | grep 'root$' | awk '{print $2}') .
-    chattr -Rf +C root
-    cd /
-    umount /mnt
-}
+if ifclass frodo; then
+    # next upgrade is prolly 16 gigs of memory, across ~8 devices
+    swap_end=$((3500 + boot_end))
+else
+    # 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
+    swap_end=$(( $(grep ^MemTotal: /proc/meminfo| awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1000 + boot_end ))
+fi
 
 mkdir -p /tmp/fai
 shopt -s nullglob
@@ -96,11 +99,11 @@ if $partition; then
         # gpt ubuntu cloud image uses ~4. fai uses 1 MiB. ehh, i'll do 4.
         # also, using MB instead of MiB causes complains about alignment.
         parted -s $dev mkpart primary "ext3" 4MB ${boot_end}MiB
-        parted -s $dev set 1 boot on
         parted -s $dev mkpart primary "linux-swap" ${boot_end}MiB ${swap_end}MiB
         parted -s -- $dev mkpart primary "" ${swap_end}MiB -0
         parted -s $dev mkpart primary "" 1MiB 4MiB
-        parted -s $dev set 4 bios_grub on
+        parted -s $dev set $bios_grubn bios_grub on
+        parted -s $dev set $bootn boot on # generally not needed on modern systems
         # the mkfs failed randomly on a vm, so I threw a sleep in here.
         sleep .1
         mkfs.ext4 -F ${dev}1
@@ -132,10 +135,10 @@ if $partition; then
                        --key-file $luks_dir/host-$HOSTNAME
         done
     done
-    mkfs.btrfs -f ${crypt_devs[@]/%/3}
+    #bpart ${devs[@]/%/$rootn}
+    bpart ${crypt_devs[@]/%/3}
     parted ${devs[0]} set 1 boot on
     mount $crypt /mnt
-    create_subvols
 else
     for dev in ${devs[@]}; do
         mkfs.ext4 -F ${dev}1
@@ -150,9 +153,25 @@ else
     for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
     btrfs subvolume set-default 0 /mnt
     btrfs subvolume delete /mnt/root
-    create_subvols
 fi
 
+## create subvols ##
+cd /mnt
+for x in q home root; do
+    btrfs subvolume list . | grep "$x$" >/dev/null || btrfs subvolume create $x
+done
+for x in root/a q/a; do
+    mkdir -p $x
+    chown 1000:1000 $x
+    chmod 755 $x
+done
+btrfs subvolume set-default \
+      $(btrfs subvolume list . | grep 'root$' | awk '{print $2}') .
+chattr -Rf +C root
+cd /
+umount /mnt
+## end create subvols ##
+
 
 
 cat > /tmp/fai/fstab <<EOF
@@ -166,11 +185,11 @@ EOF
 
 swaps=()
 for dev in ${devs[@]}; do
-    s=crypt_swap_${dev##/dev/}2
+    s=crypt_swap_${dev##/dev/}$swapn
     swaps+=(/dev/mapper/$s)
     cat >>/tmp/fai/crypttab <<EOF
-crypt_dev_${dev##/dev/}3  ${dev}3  none  keyscript=/root/keyscript,discard,luks
-$s ${dev}2  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
+crypt_dev_${dev##/dev/}$rootn  $dev$rootn  none  keyscript=/root/keyscript,discard,luks
+$s $dev$swapn  /dev/urandom  swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
 EOF
     cat >> /tmp/fai/fstab <<EOF
 /dev/mapper/$s  none  swap  sw  0 0